CSFML - C binding of the Simple and Fast Multimedia Library

CSFML 3.0.0

- Main Page
- Classes
- Files

- File List
- File Members

Loading...
Searching...
No Matches
Functions
TcpSocket.h File Reference
`#include <CSFML/Network/Export.h>`
`#include <CSFML/Network/IpAddress.h>`
`#include <CSFML/Network/SocketStatus.h>`
`#include <CSFML/Network/Types.h>`
`#include <CSFML/System/Time.h>`
`#include <stddef.h>`

Go to the source code of this file.

## Functions
sfTcpSocket * | sfTcpSocket_create (void)
| Create a new TCP socket.
void | sfTcpSocket_destroy (const sfTcpSocket *socket)
| Destroy a TCP socket.
void | sfTcpSocket_setBlocking (sfTcpSocket *socket, bool blocking)
| Set the blocking state of a TCP listener.
bool | sfTcpSocket_isBlocking (const sfTcpSocket *socket)
| Tell whether a TCP socket is in blocking or non-blocking mode.
unsigned short | sfTcpSocket_getLocalPort (const sfTcpSocket *socket)
| Get the port to which a TCP socket is bound locally.
sfIpAddress | sfTcpSocket_getRemoteAddress (const sfTcpSocket *socket)
| Get the address of the connected peer of a TCP socket.
unsigned short | sfTcpSocket_getRemotePort (const sfTcpSocket *socket)
| Get the port of the connected peer to which a TCP socket is connected.
sfSocketStatus | sfTcpSocket_connect (sfTcpSocket *socket, sfIpAddress remoteAddress, unsigned short remotePort, sfTime timeout)
| Connect a TCP socket to a remote peer.
void | sfTcpSocket_disconnect (sfTcpSocket *socket)
| Disconnect a TCP socket from its remote peer.
sfSocketStatus | sfTcpSocket_send (sfTcpSocket *socket, const void *data, size_t size)
| Send raw data to the remote peer of a TCP socket.
sfSocketStatus | sfTcpSocket_sendPartial (sfTcpSocket *socket, const void *data, size_t size, size_t *sent)
| Send raw data to the remote peer.
sfSocketStatus | sfTcpSocket_receive (sfTcpSocket *socket, void *data, size_t size, size_t *received)
| Receive raw data from the remote peer of a TCP socket.
sfSocketStatus | sfTcpSocket_sendPacket (sfTcpSocket *socket, sfPacket *packet)
| Send a formatted packet of data to the remote peer of a TCP socket.
sfSocketStatus | sfTcpSocket_receivePacket (sfTcpSocket *socket, sfPacket *packet)
| Receive a formatted packet of data from the remote peer.

## Function Documentation

## ◆ sfTcpSocket_connect()

sfSocketStatus sfTcpSocket_connect | ( | sfTcpSocket * | socket,
|  | sfIpAddress | remoteAddress,
|  | unsigned short | remotePort,
|  | sfTime | timeout )

Connect a TCP socket to a remote peer.

In blocking mode, this function may take a while, especially if the remote peer is not reachable. The last parameter allows you to stop trying to connect after a given timeout. If the socket was previously connected, it is first disconnected.

Parameters

  socket | TCP socket object
  remoteAddress | Address of the remote peer
  remotePort | Port of the remote peer
  timeout | Maximum time to wait

Returns
  Status code

## ◆ sfTcpSocket_create()

sfTcpSocket * sfTcpSocket_create | ( | void |  | ) |

Create a new TCP socket.

Returns
  A new sfTcpSocket object

## ◆ sfTcpSocket_destroy()

void sfTcpSocket_destroy | ( | const sfTcpSocket * | socket | ) |

Destroy a TCP socket.

Parameters

  socket | TCP socket to destroy

## ◆ sfTcpSocket_disconnect()

void sfTcpSocket_disconnect | ( | sfTcpSocket * | socket | ) |

Disconnect a TCP socket from its remote peer.

This function gracefully closes the connection. If the socket is not connected, this function has no effect.

Parameters

  socket | TCP socket object

## ◆ sfTcpSocket_getLocalPort()

unsigned short sfTcpSocket_getLocalPort | ( | const sfTcpSocket * | socket | ) |

Get the port to which a TCP socket is bound locally.

If the socket is not connected, this function returns 0.

Parameters

  socket | TCP socket object

Returns
  Port to which the socket is bound

## ◆ sfTcpSocket_getRemoteAddress()

sfIpAddress sfTcpSocket_getRemoteAddress | ( | const sfTcpSocket * | socket | ) |

Get the address of the connected peer of a TCP socket.

If the socket is not connected, this function returns sfIpAddress_None.

Parameters

  socket | TCP socket object

Returns
  Address of the remote peer

## ◆ sfTcpSocket_getRemotePort()

unsigned short sfTcpSocket_getRemotePort | ( | const sfTcpSocket * | socket | ) |

Get the port of the connected peer to which a TCP socket is connected.

If the socket is not connected, this function returns 0.

Parameters

  socket | TCP socket object

Returns
  Remote port to which the socket is connected

## ◆ sfTcpSocket_isBlocking()

bool sfTcpSocket_isBlocking | ( | const sfTcpSocket * | socket | ) |

Tell whether a TCP socket is in blocking or non-blocking mode.

Parameters

  socket | TCP socket object

Returns
  true if the socket is blocking, false otherwise

## ◆ sfTcpSocket_receive()

sfSocketStatus sfTcpSocket_receive | ( | sfTcpSocket * | socket,
|  | void * | data,
|  | size_t | size,
|  | size_t * | received )

Receive raw data from the remote peer of a TCP socket.

In blocking mode, this function will wait until some bytes are actually received. This function will fail if the socket is not connected.

Parameters

  socket | TCP socket object
  data | Pointer to the array to fill with the received bytes
  size | Maximum number of bytes that can be received
  received | This variable is filled with the actual number of bytes received

Returns
  Status code

## ◆ sfTcpSocket_receivePacket()

sfSocketStatus sfTcpSocket_receivePacket | ( | sfTcpSocket * | socket,
|  | sfPacket * | packet )

Receive a formatted packet of data from the remote peer.

In blocking mode, this function will wait until the whole packet has been received. This function will fail if the socket is not connected.

Parameters

  socket | TCP socket object
  packet | Packet to fill with the received data

Returns
  Status code

## ◆ sfTcpSocket_send()

sfSocketStatus sfTcpSocket_send | ( | sfTcpSocket * | socket,
|  | const void * | data,
|  | size_t | size )

Send raw data to the remote peer of a TCP socket.

To be able to handle partial sends over non-blocking sockets, use the sfTcpSocket_sendPartial(sfTcpSocket*, const void*, size_t, size_t*) overload instead. This function will fail if the socket is not connected.

Parameters

  socket | TCP socket object
  data | Pointer to the sequence of bytes to send
  size | Number of bytes to send

Returns
  Status code

## ◆ sfTcpSocket_sendPacket()

sfSocketStatus sfTcpSocket_sendPacket | ( | sfTcpSocket * | socket,
|  | sfPacket * | packet )

Send a formatted packet of data to the remote peer of a TCP socket.

In non-blocking mode, if this function returns sfSocketPartial, you must retry sending the same unmodified packet before sending anything else in order to guarantee the packet arrives at the remote peer uncorrupted. This function will fail if the socket is not connected.

Parameters

  socket | TCP socket object
  packet | Packet to send

Returns
  Status code

## ◆ sfTcpSocket_sendPartial()

sfSocketStatus sfTcpSocket_sendPartial | ( | sfTcpSocket * | socket,
|  | const void * | data,
|  | size_t | size,
|  | size_t * | sent )

Send raw data to the remote peer.

This function will fail if the socket is not connected.

Parameters

  socket | TCP socket object
  data | Pointer to the sequence of bytes to send
  size | Number of bytes to send
  sent | The number of bytes sent will be written here

Returns
  Status code

## ◆ sfTcpSocket_setBlocking()

void sfTcpSocket_setBlocking | ( | sfTcpSocket * | socket,
|  | bool | blocking )

Set the blocking state of a TCP listener.

In blocking mode, calls will not return until they have completed their task. For example, a call to sfTcpSocket_receive in blocking mode won't return until new data was actually received. In non-blocking mode, calls will always return immediately, using the return code to signal whether there was data available or not. By default, all sockets are blocking.

Parameters

  socket | TCP socket object
  blocking | true to set the socket as blocking, false for non-blocking